using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;

namespace SuperTicTacToe
{
    
    /// <summary>
    /// This is the main type for your game
    /// there is one instance of BigBoard, It has an array[3, 3] of SmallBoards, each with an array[3, 3] of Spaces.
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;
        BigBoard bigBoard = new BigBoard();
        public static int PlayersTurn;
        private MouseState oldState;

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            graphics.PreferredBackBufferWidth = 704;  // set this value to the desired width of your window
            graphics.PreferredBackBufferHeight = 704;   // set this value to the desired height of your window
            graphics.ApplyChanges();
            Content.RootDirectory = "Content";
        }

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            // TODO: Add your initialization logic here
            this.IsMouseVisible = true;
            base.Initialize();
        }
     

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
            //a X, O or Nothing Texture is a exact 64 pixel square.
            //a Small board texture is a exact 224 pixel square.. which is three 64 images.. and two 16 pixel borders 
            //the Big board is a 704 pixel image, which is three 224 images with two 16 pixel borders.
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);
            BigBoard.bigBoardTexture = (Content.Load<Texture2D>("bigboard"));
            SmallBoard.smallBoardTexture = (Content.Load<Texture2D>("newboard"));
            SmallBoard.boardWinO = (Content.Load<Texture2D>("boardwinO"));
            SmallBoard.boardWinX = (Content.Load<Texture2D>("boardwinX"));
            Space.textureX = (Content.Load<Texture2D>("X test2"));
            Space.textureO = (Content.Load<Texture2D>("O test2"));
            Space.textureNone = (Content.Load<Texture2D>("markX"));
            
            //x = (Content.Load<Texture2D>("markX"));
            //o = (Content.Load<Texture2D>("MarkO"));
            //x2 = (Content.Load<Texture2D>("X test1"));
            //o2 = (Content.Load<Texture2D>("O test1"));
            //x3 = (Content.Load<Texture2D>("X test2"));
            //o3 = (Content.Load<Texture2D>("O test2"));

            // TODO: use this.Content to load your game content here
            
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // Allows the game to exit
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();

            MouseState newState = Mouse.GetState();
            Space.mouseStateSquareCS = newState;


            if (newState.LeftButton == ButtonState.Pressed && oldState.LeftButton == ButtonState.Released) //basiclly this tells EVERY square instance to exucute the code to dectect if the mouse is inside the square.
            {
                Space.mousePressed = true;
            }
            else
            {
                Space.mousePressed = false;
            }
            oldState = newState;

            if (BigBoard.gameOver == false)
            {
                bigBoard.Update();
            }
            // TODO: Add your update logic here

            base.Update(gameTime);
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Color.CornflowerBlue);
            spriteBatch.Begin();
            bigBoard.Draw(spriteBatch);
            spriteBatch.End();
            base.Draw(gameTime);
        }
    }
}
