﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;

namespace SuperTicTacToe
{
    public class SmallBoard
    {
        // Column is first number (O, X, X) is 0,0 1,0 and 2,0
        // Row is second number   (X, -, -) is 0,1 1,1 and 2,1

        Vector2 location;
        public static Texture2D smallBoardTexture;
        public static Texture2D boardWinO;
        public static Texture2D boardWinX;
        private Texture2D currentTexture;
        private bool hasWonPermanently = false;
        Rectangle locationSquare;
        private Space[,] smallBoardSpaces = new Space[3, 3];
        public SmallBoard(float currentBoardCol, float currentBoardRow)
        {
            location = new Vector2((currentBoardCol * (224 + 16)),(currentBoardRow * (224 + 16)));
            locationSquare = new Rectangle((int)location.X, (int)location.Y, 224, 224);
            for (int indexcol = 0; indexcol < 3; indexcol++) //This for loop code is used every time I want to do something to every object in the 3x3 array.. which we have multiple 3x3 arrays
            {
                for (int indexrow = 0; indexrow < 3; indexrow++)
                {
                    smallBoardSpaces[indexrow, indexcol] = new Space(location, indexcol, indexrow);
                }
            }
        }
        public void Update()
        {
            for (int indexcol = 0; indexcol < 3; indexcol++) //This for loop code is used every time I want to do something to every object in the 3x3 array.. which we have multiple 3x3 arrays
            { //loop code
                for (int indexrow = 0; indexrow < 3; indexrow++) //loop code
                { //loop code
                    //do code here
                    smallBoardSpaces[indexrow, indexcol].Update();
                    
                    if (hasWonPermanently == false) //this is to prevent from wining again.
                    {
                        if (getHasWon(1) == true)
                        {
                            BigBoard.totalWinsX++;
                            hasWonPermanently = true;
                            currentTexture = boardWinX;
                        }
                        else if (getHasWon(2) == true)
                        {
                            BigBoard.totalWinsO++;
                            hasWonPermanently = true;
                            currentTexture = boardWinO;
                        }
                        if (hasWonPermanently == false)
                        {
                            currentTexture = smallBoardTexture;
                        }
                    }
                } //loop code
            } //loop code

        }

        public bool getBoardFull()
        {
            for (int indexcol = 0; indexcol < 3; indexcol++) //This for loop code is used every time I want to do something to every object in the 3x3 array.. which we have multiple 3x3 arrays
            { //loop code
                for (int indexrow = 0; indexrow < 3; indexrow++) //loop code
                { //loop code
                    if ((smallBoardSpaces[indexrow, indexcol].contains == 0))
                    {
                        return false;
                    }
                }
            }
            return true;
        }

        public bool getHasWon(int XorO) //this checks all possible wins for XorO (0,1 or 2 (0 being nothing, 1 being X or 2 being O)) and returns a true or false.
        {
            if ((smallBoardSpaces[0, 0].contains == XorO) && (smallBoardSpaces[1, 1].contains == XorO) && (smallBoardSpaces[2, 2].contains == XorO))
            {
                return true;
            }
            else if ((smallBoardSpaces[0, 2].contains == XorO) && (smallBoardSpaces[1, 1].contains == XorO) && (smallBoardSpaces[2, 0].contains == XorO))
            {
                return true;
            }
            for (int zeroToTwo = 0; zeroToTwo <= 2; zeroToTwo++)
            {
                if ((smallBoardSpaces[zeroToTwo, 0].contains == XorO) && (smallBoardSpaces[zeroToTwo, 1].contains == XorO) && (smallBoardSpaces[zeroToTwo, 2].contains == XorO)) //.contains is XorO.. 0 is nothing, 1 is X, 2 is O.
                {
                    return true;
                }
                else if ((smallBoardSpaces[0, zeroToTwo].contains == XorO) && (smallBoardSpaces[1, zeroToTwo].contains == XorO) && (smallBoardSpaces[2, zeroToTwo].contains == XorO))
                {
                    return true;
                }
                
            }
            return false;
        }
        public void Draw(SpriteBatch spritebatch)
        {
            spritebatch.Draw(currentTexture, locationSquare, Color.White);
            for (int indexcol = 0; indexcol < 3; indexcol++)
            {
                for (int indexrow = 0; indexrow < 3; indexrow++)
                {
                    smallBoardSpaces[indexcol, indexrow].Draw(spritebatch);
                }
            }
        }
    }
}
